#! /usr/bin/perl -w
use strict;

my $usage = "\nappend_lineage.pl Usage:\n
perl $0 [blastp_taxid_file] [tax_report.txt]:\n
[blastp_taxid_file]: The .blastp.tab.taxid file generated by mapping_to_ncbi_taxonomy.pl in Step 2.2
[tax_report.txt]: The tax_report.txt file generated online at http://www.ncbi.nlm.nih.gov/Taxonomy/TaxIdentifier/tax_identifier.cgi
$!\n";
my $blastp_taxid_file = shift || die $usage;
my $tax_report = shift || die $usage;
my $out = "taxid_lineage.txt";

my %hash;
open TAX,$tax_report || die "OOPS!Cannot open $tax_report for reading:$!\n";
while (<TAX>) {
	chomp;
	next if (!(/^\d/));
	my($taxid,$name,$lineage)=(split /\t\|\t/)[1,2,-1];
	next if (!(defined($name)));
	$hash{$taxid}{$name}=$lineage;
}
close TAX;

my %mark;
open OUT,'>',$out || die "OOPS!Cannot write to $out:$!\n";
open CC,$blastp_taxid_file || die "OOPS!Cannot open $blastp_taxid_file for reading:$!\n";
while (<CC>) {
	chomp;
	my ($ccid,$e,$taxid) = (split /\t/)[0,-2,-1];
	next if (!(defined($hash{$taxid})));
	next if (defined($mark{$ccid}{$taxid}));
	$mark{$ccid}{$taxid} ++;
	my ($name) = (keys %{$hash{$taxid}});
	my $lineage = $hash{$taxid}{$name};
	print OUT "$ccid\t$e\t$taxid\t$name\t$lineage\n";
}
close CC;
close OUT;